From 6f5fe8c9d101b5218053deb9cc60f67436b850e0 Mon Sep 17 00:00:00 2001
From: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date: Thu, 5 Dec 2013 21:41:55 +0100
Subject: [PATCH 262/291] cryptodev: doc

---
 drivers/staging/crypto/cryptodev/NEWS | 79 ++++++++++++++++-------------------
 1 file changed, 35 insertions(+), 44 deletions(-)

diff --git a/drivers/staging/crypto/cryptodev/NEWS b/drivers/staging/crypto/cryptodev/NEWS
index 80614b4cdd4a..89176add454e 100644
--- a/drivers/staging/crypto/cryptodev/NEWS
+++ b/drivers/staging/crypto/cryptodev/NEWS
@@ -2,8 +2,10 @@ Version 1.7 (unreleased)
 
 * Several bugfixes by Cristian Stoica.
 
-* Added support for sysctl to modify verbosity by 
-Nikolaos Tsakalakis.
+* Added support for sysctl to modify verbosity by Nikolaos Tsakalakis.
+
+* When a driver requires aligned data but unaligned are provided, then
+  zero copy is disabled to prevent driver failing to encrypt.
 
 
 Version 1.6 (released 2013-03-20)
@@ -12,11 +14,10 @@ Version 1.6 (released 2013-03-20)
 
 * Added SHA224. Patch by Yashpal Dutta.
 
-* Asynchronous operations will not be scheduled if zero
-copy is disabled.
+* Asynchronous operations will not be scheduled if zero copy is disabled.
 
-* Asynchronous operations are disabled by default, unless
--DENABLE_ASYNC is enabled on Makefile.
+* Asynchronous operations are disabled by default, unless -DENABLE_ASYNC 
+  is enabled on Makefile.
 
 
 Version 1.5 (released 2012-08-04)
@@ -25,8 +26,8 @@ Version 1.5 (released 2012-08-04)
 
 * Simplifications in memory locking. Patch by Phil Sutter.
 
-* Allow empty plaintext and authenticated data in AEAD 
-ciphers. Patch by Jaren Johnston.
+* Allow empty plaintext and authenticated data in AEAD  ciphers. 
+  Patch by Jaren Johnston.
 
 
 Version 1.4 (released 2012-03-15)
@@ -36,11 +37,10 @@ Version 1.4 (released 2012-03-15)
 
 Version 1.3 (released 2012-02-29)
 
-* Return EBADMSG instead of ECANCELED on tag verification
-failure in authenc modes.
+* Return EBADMSG instead of ECANCELED on tag verification failure in 
+  authenc modes.
 
-* COP_FLAG_RESET can be combined with COP_FLAG_UPDATE for
-efficiency.
+* COP_FLAG_RESET can be combined with COP_FLAG_UPDATE for efficiency.
 
 * Added more test cases.
 
@@ -49,14 +49,12 @@ efficiency.
 
 Version 1.2 (released 2012-02-24)
 
-* In kernels that do not distinguish between hw 
-accelerated ciphers or not set the SIOP_FLAG_KERNEL_DRIVER_ONLY
-flag based on driver name.
+* In kernels that do not distinguish between hw accelerated ciphers or 
+  not set the SIOP_FLAG_KERNEL_DRIVER_ONLY flag based on driver name.
 
 * camelia was renamed to camellia.
 
-* Added COP_FLAG_RESET to allow resetting the state
-in multi-update.
+* Added COP_FLAG_RESET to allow resetting the state in multi-update.
 
 * Corrected issue in ARM processors with mv_cesa.
 
@@ -67,20 +65,19 @@ Version 1.1 (released 2012-02-20)
 
 * Defined HASH_MAX_LEN in cryptodev.h
 
-* CIOCGSESSINFO ioctl() sets the SIOP_FLAG_KERNEL_DRIVER_ONLY 
-flag if the driver is only available through kernel
-driver (and is not just software cipher).
+* CIOCGSESSINFO ioctl() sets the SIOP_FLAG_KERNEL_DRIVER_ONLY flag if the 
+  driver is only available through kernel driver (and is not just software 
+  cipher).
 
-* Added new encryption ioctl, CIOCAUTHCRYPT, which
-combines authentication and encryption. Operates
-in AEAD, TLS and SRTP modes (the API might change
-in later versions).
+* Added new encryption ioctl, CIOCAUTHCRYPT, which combines authentication 
+  and encryption. Operates in AEAD, TLS and SRTP modes (the API might change
+  in later versions).
 
 
 Version 1.0 (released 2011-04-12)
 
-* Several fixes in the included examples. Based on
-patches by Vladimir Zapolskiy.
+* Several fixes in the included examples. Based on patches by Vladimir 
+  Zapolskiy.
 
 
 Version 0.9 (released 2011-02-11)
@@ -89,15 +86,13 @@ Version 0.9 (released 2011-02-11)
   - sha_speed does performance testing of SHA1 and SHA256
   - hashcrypt_speed additionally encrypts with AES128 and AES256
 
-* Allow updating the IV in userspace via the COP_FLAG_WRITE_IV
-flag.
+* Allow updating the IV in userspace via the COP_FLAG_WRITE_IV flag.
 
 * Export the alignmask in an OCF compatible way.
 
 * Fix for kernel crash on passing incorrect session ID.
 
-* Added CIOCGSESSINFO to export additional information
-for each session.
+* Added CIOCGSESSINFO to export additional information for each session.
 
 
 Version 0.8 (released 2010-11-06)
@@ -112,39 +107,35 @@ Version 0.8 (released 2010-11-06)
 
 Version 0.7 (released 2010-10-08)
 
-* Added COP_FLAG_FINAL to make multi-update
-more efficient.
+* Added COP_FLAG_FINAL to make multi-update more efficient.
 
-* Added CRIOGET_NOT_NEEDED definition to allow
-users of the API to distinguish from the bare
-OpenBSD API that requires the CRIOGET.
+* Added CRIOGET_NOT_NEEDED definition to allow users of the API to 
+  distinguish from the bare OpenBSD API that requires the CRIOGET.
 
 
 Version 0.6 (released 2010-09-16)
 
-* multi-update support for hash calculation using
-the new flag COP_FLAG_UPDATE.
+* multi-update support for hash calculation using the new flag 
+  COP_FLAG_UPDATE.
 
 * Relicensed under GPLv2.
 
 * Added AES-CTR.
 
-* Corrected fallback to non-zero copy when referenced
-pages were not writable.
+* Corrected fallback to non-zero copy when referenced pages were 
+  not writable.
 
 
 Version 0.5 (released 2010-07-06)
 
 * Corrected issue with zero copy on multiple pages.
 
-* Fallback to normal operation if user pages cannot be
-mapped.
+* Fallback to normal operation if user pages cannot be mapped.
 
 
 Version 0.4 (released 2010-07-03)
 
-* Internal engine supports operations with zero copy from
-user space. 
+* Internal engine supports operations with zero copy from user space. 
 
 
 Version 0.3 (released 2010-06-19)
@@ -155,7 +146,7 @@ Version 0.3 (released 2010-06-19)
 Version 0.2 (released 2010-06-18)
 
 * Added compat_ioctl() to allow working on systems where userspace is 32bits
-and kernel is operating in 64bit mode (Phil Sutter)
+  and kernel is operating in 64bit mode (Phil Sutter)
 
 * Added several sanity checks to input.
 
-- 
2.1.0