From 729fcf773edf7a0f59505218f7a63895d6e3e6cf Mon Sep 17 00:00:00 2001
From: Phil Sutter <phil@nwl.cc>
Date: Wed, 29 Jan 2014 03:24:18 +0100
Subject: [PATCH 265/291] cryptodev: checkpatch

Signed-off-by: Phil Sutter <phil@nwl.cc>
---
 drivers/staging/crypto/cryptodev/authenc.c       | 6 +++---
 drivers/staging/crypto/cryptodev/cryptlib.c      | 2 +-
 drivers/staging/crypto/cryptodev/cryptodev_int.h | 4 ++--
 drivers/staging/crypto/cryptodev/ioctl.c         | 2 +-
 drivers/staging/crypto/cryptodev/zc.c            | 6 +++---
 drivers/staging/crypto/cryptodev/zc.h            | 6 +++---
 6 files changed, 13 insertions(+), 13 deletions(-)

diff --git a/drivers/staging/crypto/cryptodev/authenc.c b/drivers/staging/crypto/cryptodev/authenc.c
index 74f9c9bbab47..9edcf07f221f 100644
--- a/drivers/staging/crypto/cryptodev/authenc.c
+++ b/drivers/staging/crypto/cryptodev/authenc.c
@@ -276,12 +276,12 @@ int kcaop_to_user(struct kernel_crypt_auth_op *kcaop,
 	return 0;
 }
 
-static void copy_tls_hash( struct scatterlist *dst_sg, int len, void* hash, int hash_len)
+static void copy_tls_hash( struct scatterlist *dst_sg, int len, void *hash, int hash_len)
 {
 	scatterwalk_map_and_copy(hash, dst_sg, len, hash_len, 1);
 }
 
-static void read_tls_hash( struct scatterlist *dst_sg, int len, void* hash, int hash_len)
+static void read_tls_hash( struct scatterlist *dst_sg, int len, void *hash, int hash_len)
 {
 	scatterwalk_map_and_copy(hash, dst_sg, len-hash_len, hash_len, 0);
 }
@@ -615,7 +615,7 @@ __crypto_auth_run_zc(struct csession *ses_ptr, struct kernel_crypt_auth_op *kcao
 	          * so we just copy them to a free page, instead of trying
 	          * to map them.
 	          */
-		unsigned char* auth_buf = NULL;
+		unsigned char *auth_buf = NULL;
 		struct scatterlist tmp;
 
 		if (unlikely(caop->auth_len > PAGE_SIZE)) {
diff --git a/drivers/staging/crypto/cryptodev/cryptlib.c b/drivers/staging/crypto/cryptodev/cryptlib.c
index a923c1449c46..d9f17ee02466 100644
--- a/drivers/staging/crypto/cryptodev/cryptlib.c
+++ b/drivers/staging/crypto/cryptodev/cryptlib.c
@@ -359,7 +359,7 @@ ssize_t cryptodev_hash_update(struct hash_data *hdata,
 	return waitfor(hdata->async.result, ret);
 }
 
-int cryptodev_hash_final(struct hash_data *hdata, void* output)
+int cryptodev_hash_final(struct hash_data *hdata, void *output)
 {
 	int ret;
 
diff --git a/drivers/staging/crypto/cryptodev/cryptodev_int.h b/drivers/staging/crypto/cryptodev/cryptodev_int.h
index 188063daea82..c01e61965dbe 100644
--- a/drivers/staging/crypto/cryptodev/cryptodev_int.h
+++ b/drivers/staging/crypto/cryptodev/cryptodev_int.h
@@ -131,10 +131,10 @@ struct csession {
 
 struct csession *crypto_get_session_by_sid(struct fcrypt *fcr, uint32_t sid);
 
-inline static void crypto_put_session(struct csession * ses_ptr)
+inline static void crypto_put_session(struct csession *ses_ptr)
 {
 	mutex_unlock(&ses_ptr->sem);
 }
-int adjust_sg_array(struct csession * ses, int pagecount);
+int adjust_sg_array(struct csession *ses, int pagecount);
 
 #endif /* CRYPTODEV_INT_H */
diff --git a/drivers/staging/crypto/cryptodev/ioctl.c b/drivers/staging/crypto/cryptodev/ioctl.c
index 999fb313ec91..9e239d0d2395 100644
--- a/drivers/staging/crypto/cryptodev/ioctl.c
+++ b/drivers/staging/crypto/cryptodev/ioctl.c
@@ -717,7 +717,7 @@ static inline void tfm_info_to_alg_info(struct alg_info *dst, struct crypto_tfm
 #ifndef CRYPTO_ALG_KERN_DRIVER_ONLY
 static unsigned int is_known_accelerated(struct crypto_tfm *tfm)
 {
-	const char* name = crypto_tfm_alg_driver_name(tfm);
+	const char *name = crypto_tfm_alg_driver_name(tfm);
 
 	if (name == NULL)
 	  return 1; /* assume accelerated */
diff --git a/drivers/staging/crypto/cryptodev/zc.c b/drivers/staging/crypto/cryptodev/zc.c
index 11492e404db7..774a0d8ce135 100644
--- a/drivers/staging/crypto/cryptodev/zc.c
+++ b/drivers/staging/crypto/cryptodev/zc.c
@@ -80,7 +80,7 @@ int __get_userbuf(uint8_t __user *addr, uint32_t len, int write,
 	return 0;
 }
 
-int adjust_sg_array(struct csession * ses, int pagecount)
+int adjust_sg_array(struct csession *ses, int pagecount)
 {
 	struct scatterlist *sg;
 	struct page **pages;
@@ -128,8 +128,8 @@ void release_user_pages(struct csession *ses)
  * dst might be the same as src.
  */
 int get_userbuf(struct csession *ses,
-                void* __user src, unsigned int src_len,
-                void* __user dst, unsigned int dst_len,
+                void *__user src, unsigned int src_len,
+                void *__user dst, unsigned int dst_len,
                 struct task_struct *task, struct mm_struct *mm,
                 struct scatterlist **src_sg,
                 struct scatterlist **dst_sg)
diff --git a/drivers/staging/crypto/cryptodev/zc.h b/drivers/staging/crypto/cryptodev/zc.h
index b52616ead1ff..6f975d6eb15e 100644
--- a/drivers/staging/crypto/cryptodev/zc.h
+++ b/drivers/staging/crypto/cryptodev/zc.h
@@ -7,11 +7,11 @@
 int __get_userbuf(uint8_t __user *addr, uint32_t len, int write,
 		unsigned int pgcount, struct page **pg, struct scatterlist *sg,
 		struct task_struct *task, struct mm_struct *mm);
-void release_user_pages(struct csession* ses);
+void release_user_pages(struct csession *ses);
 
 int get_userbuf(struct csession *ses,
-                void* __user src, unsigned int src_len,
-                void* __user dst, unsigned int dst_len,
+                void *__user src, unsigned int src_len,
+                void *__user dst, unsigned int dst_len,
                 struct task_struct *task, struct mm_struct *mm,
                 struct scatterlist **src_sg,
                 struct scatterlist **dst_sg);
-- 
2.1.0